//+------------------------------------------------------------------+
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

//
//
//
//
//

extern int    MAGIC                = 98765432;
extern string Name_Expert          = "Dss Ichi";
extern bool   EcnBroker            = true;
extern double lStopLoss            = 150;
extern double sStopLoss            = 150;
extern double lTakeProfit          = 70;
extern double sTakeProfit          = 70;
extern double lTrailingStop        = 20;
extern double sTrailingStop        = 20;
extern int    Slippage             = 4;
extern double Lots                 = 0.01;
extern double MaximumRisk          = 0;
extern double DecreaseFactor       = 3;
extern bool   useStochClose        = true;

extern int    Tenkan               = 72;
extern int    Kijun                = 144;
extern int    Senkou               = 288;
extern int    ChinkouShift         = -144;
extern int    tf                   = 5;
extern int    tf2                  = 240;

extern int    Stochastic.Period    = 100;
extern int    Ema.Smoothing.Period = 8;
extern double Up.Level             = 80;
extern double Dn.Level             = 20;
extern int    bar                  = 1;


extern bool   UseHourTrade         = false;
extern int    FromHourTrade        = 8;
extern int    ToHourTrade          = 19;

extern color  clOpenBuy            = Blue;
extern color  clCloseBuy           = Aqua;
extern color  clOpenSell           = Red;
extern color  clCloseSell          = Violet;
extern color  clModiBuy            = Blue;
extern color  clModiSell           = Red;

//
//
//
//
//

double pipMultiplier = 1;

//
//
//
//
//

int init() {  return(0); }

//
//
//
//
//

int deinit() { Comment(""); return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   if (Digits == 3 || Digits == 5) 
         pipMultiplier = 10;
   else  pipMultiplier = 1;  
   
   //
   //
   //
   //
   //
   
   if(Bars < 100) { Print("bars less than 100"); return(0); }
   
   //
   //
   //
   //
   //
   
   if (UseHourTrade)
   {
     if(!(Hour() >= FromHourTrade && Hour() <= ToHourTrade)) { Comment("Non-Trading Hours!");  return(0);  }
   }
   
   //
   //
   //
   //
   //
   
   if(lStopLoss   < 10) {  Print("StopLoss less than 10");   return(0);  }
   if(lTakeProfit < 10) {  Print("TakeProfit less than 10"); return(0);  }
   if(sStopLoss   < 10) {  Print("StopLoss less than 10");   return(0);  }
   if(sTakeProfit < 10) {  Print("TakeProfit less than 10"); return(0);  }
   
   //
   //
   //
   //
   //
   
   double Var1   = iCustom(NULL,tf, "Ichimoku2",Tenkan,Kijun,Senkou,ChinkouShift,0,bar);
   double Var2   = iCustom(NULL,tf, "Ichimoku2",Tenkan,Kijun,Senkou,ChinkouShift,1,bar);
   double Var3   = iCustom(NULL,tf2,"Ichimoku2",Tenkan,Kijun,Senkou,ChinkouShift,0,bar);
   double Var4   = iCustom(NULL,tf2,"Ichimoku2",Tenkan,Kijun,Senkou,ChinkouShift,1,bar);
   double Var5   = iCustom(NULL,tf, "Ichimoku2",Tenkan,Kijun,Senkou,ChinkouShift,2,bar);
   double Var6   = iCustom(NULL,tf2,"Ichimoku2",Tenkan,Kijun,Senkou,ChinkouShift,2,bar);
   double Var9   = iClose(NULL,tf,bar); 
   double Var10  = iClose(NULL,tf2,bar);
   double stonow = iCustom(NULL,0,"Double smoothed stochastic 2",Stochastic.Period,Ema.Smoothing.Period,0,bar);
   double stopre = iCustom(NULL,0,"Double smoothed stochastic 2",Stochastic.Period,Ema.Smoothing.Period,0,bar+1);
   
   
 
   if (!ExistPositions())
   {
      
      if (Var1 > Var2 && Var3 > Var4 && Var9 > Var5 && Var10 > Var6 && stonow > stopre && stonow >= Dn.Level && stopre < Dn.Level) 
      {
         OpenBuy();
         return(0);
      }

      if (Var1 < Var2 && Var3 < Var4 && Var9 < Var5 && Var10 < Var6 && stonow < stopre && stonow <= Up.Level && stopre > Up.Level) 
      {
         OpenSell();
         return(0);
      }
      
   if (useStochClose)
   {
      
      if (stonow > stopre && stonow >= Dn.Level && stopre < Dn.Level)
      {
         closeSell();
         return(0);
      }
      
      if (stonow < stopre && stonow <= Up.Level && stopre > Up.Level)
      {
         closeBuy();
         return(0);
      }
   }
   }
   TrailingPositionsBuy(lTrailingStop);
   TrailingPositionsSell(sTrailingStop);
   return (0);
}

//
//
//
//
//

bool ExistPositions() {
	for (int i=0; i<OrdersTotal(); i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol()==Symbol() && OrderMagicNumber() == MAGIC) {
				return(True);
			}
		} 
	} 
	return(false);
}

//
//
//
//
//

void TrailingPositionsBuy(int trailingStop) { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_BUY) { 
               if (Bid-OrderOpenPrice() > trailingStop * Point * pipMultiplier) { 
                  if (OrderStopLoss() < Bid-trailingStop * Point * pipMultiplier) 
                     ModifyStopLoss(Bid - trailingStop * Point * pipMultiplier); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void TrailingPositionsSell(int trailingStop) { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_SELL) { 
               if (OrderOpenPrice() - Ask > trailingStop * Point * pipMultiplier) { 
                  if (OrderStopLoss() > Ask + trailingStop * Point * pipMultiplier || OrderStopLoss() == 0)  
                     ModifyStopLoss(Ask + trailingStop * Point * pipMultiplier); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void ModifyStopLoss(double ldStopLoss) 
{ 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE); 
 
} 

//
//
//
//
//

void OpenBuy() 
{ 
    
   double ldStop = GetStopLossBuy(); 
   double ldTake = GetTakeProfitBuy(); 
   
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0); }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker) 
         OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,Slippage,ldStop,ldTake,Name_Expert,MAGIC,0,clOpenBuy); 
   else
   {
         int buyTicket = OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,Slippage * Point * pipMultiplier,0,0,Name_Expert,MAGIC,0,clOpenBuy);		    		    
         if (buyTicket >= 0)
         OrderModify(buyTicket,OrderOpenPrice(),ldStop,ldTake,0,CLR_NONE);
   }		       

}

//
//
//
//
//

void OpenSell() 
{ 

   double ldStop = GetStopLossSell(); 
   double ldTake = GetTakeProfitSell();
  
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0); }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker)
         OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,Slippage,ldStop,ldTake,Name_Expert,MAGIC,0,clOpenSell); 
   else
   {
         int sellTicket = OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,Slippage * Point * pipMultiplier,0,0,Name_Expert,MAGIC,0,clOpenSell);		    		    
         if (sellTicket >= 0)
         OrderModify(sellTicket,OrderOpenPrice(),ldStop,ldTake,0,CLR_NONE);
   }		       
} 

//
//
//
//
//

void closeSell()
{
    int totalSells;
    
    for(int cnt=0;cnt<totalSells;cnt++)
    {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MAGIC)
      if(OrderType()<=OP_SELL)  
      {
        if(OrderType()==OP_BUY)  
        {
          OrderClose(OrderTicket(),OrderLots(),Bid,Slippage*Point*pipMultiplier,clCloseSell);
          
        }
      }
   }
}

//
//
//
//
//

void closeBuy()
{
    int totalBuys;
    
    for(int cnt=0;cnt<totalBuys;cnt++)
    {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MAGIC)
      if(OrderType()<=OP_BUY)  
      {
        if(OrderType()==OP_SELL)  
        {
          OrderClose(OrderTicket(),OrderLots(),Ask,Slippage*Point*pipMultiplier,clCloseBuy);
          
        }
      }
    }
}


//
//
//
//
//

double GetStopLossBuy()    { 	return(Bid - lStopLoss   * Point * pipMultiplier); } 
double GetStopLossSell()   { 	return(Ask + sStopLoss   * Point * pipMultiplier); } 
double GetTakeProfitBuy()  { 	return(Ask + lTakeProfit * Point * pipMultiplier); } 
double GetTakeProfitSell() { 	return(Bid - sTakeProfit * Point * pipMultiplier); } 

//
//
//
//
//

double LotsOptimized()
{
   double lot_min  = MarketInfo(Symbol(),MODE_MINLOT);
   double lot_max  = MarketInfo(Symbol(),MODE_MAXLOT);
   double lot_step = MarketInfo(Symbol(),MODE_LOTSTEP);
   double contract = MarketInfo(Symbol(),MODE_LOTSIZE);
   double lot = Lots;
   int    orders = HistoryTotal();     // history orders total
   int    losses = 0;                  // number of losses orders without a break
   
   //
   //
   //
   //
   //
   
   if(lot_min < 0.0 || lot_max <= 0.0 || lot_step <= 0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage()<=0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   if (MaximumRisk > 0)
   {
   lot = NormalizeDouble(AccountFreeMargin() * MaximumRisk * AccountLeverage()/contract,2);
   }
   
   if(DecreaseFactor>0)
   {
      for(int i=orders-1;i>=0;i--)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
      if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
      
      //
      //
      //
      //
      //
      
      if(OrderProfit()>0) break;
      if(OrderProfit()<0) losses++;
      }
   if(losses>1) lot=NormalizeDouble(lot - lot * losses/DecreaseFactor,2);
   }
   
   //
   //
   //
   //
   //
   
   lot=NormalizeDouble(lot/lot_step,0)*lot_step;
   if(lot<lot_min) lot=lot_min;
   if(lot>lot_max) lot=lot_max;
   
   //
   //
   //
   //
   //
   
   return(lot);
} 

//
//
//
//
//


